// This is a generated file, modify: generate/templates/class_content.cc.
#include <nan.h>
#include <string.h>
#include <chrono>
#include <thread>

extern "C" {
#include <git2.h>
}

#include "../include/functions/copy.h"
#include "../include/macros.h"
#include "../include/cred_username.h"

#include "../include/cred.h"

#include <iostream>

using namespace std;
using namespace v8;
using namespace node;

GitCredUsername::GitCredUsername(git_cred_username *raw, bool selfFreeing)
{
  this->raw = raw;
  this->selfFreeing = selfFreeing;
}

GitCredUsername::~GitCredUsername()
{

  // this will cause an error if you have a non-self-freeing object that also needs
  // to save values. Since the object that will eventually free the object has no
  // way of knowing to free these values.

}

void GitCredUsername::InitializeComponent(Handle<v8::Object> target)
{
  NanScope();

  Local<FunctionTemplate> tpl = NanNew<FunctionTemplate>(JSNewFunction);

  tpl->InstanceTemplate()->SetInternalFieldCount(1);
  tpl->SetClassName(NanNew<String>("CredUsername"));

  NODE_SET_PROTOTYPE_METHOD(tpl, "parent", Parent);
  NODE_SET_PROTOTYPE_METHOD(tpl, "username", Username);

  Local<Function> _constructor_template = tpl->GetFunction();
  NanAssignPersistent(constructor_template, _constructor_template);
  target->Set(NanNew<String>("CredUsername"), _constructor_template);
}

NAN_METHOD(GitCredUsername::JSNewFunction)
{
  NanScope();

  if (args.Length() == 0 || !args[0]->IsExternal()) {
    return NanThrowError("A new GitCredUsername cannot be instantiated.");
  }

  GitCredUsername* object = new GitCredUsername(static_cast<git_cred_username *>(Handle<External>::Cast(args[0])->Value()), args[1]->BooleanValue());
  object->Wrap(args.This());

  NanReturnValue(args.This());
}

Handle<v8::Value> GitCredUsername::New(void *raw, bool selfFreeing)
{
  NanEscapableScope();
  Handle<v8::Value> argv[2] = { NanNew<External>((void *)raw), NanNew<Boolean>(selfFreeing) };
  return NanEscapeScope(NanNew<Function>(GitCredUsername::constructor_template)->NewInstance(2, argv));
}

git_cred_username *GitCredUsername::GetValue()
{
  return this->raw;
}

git_cred_username **GitCredUsername::GetRefValue()
{
  return this->raw == NULL ? NULL : &this->raw;
}

void GitCredUsername::ClearValue()
{
  this->raw = NULL;
}

NAN_METHOD(GitCredUsername::Parent)
{
  NanScope();
  Handle<v8::Value> to;

  git_cred
  *
  parent =
    &
    ObjectWrap::Unwrap<GitCredUsername>(args.This())->GetValue()->parent;
// start convert_to_v8 block

  if (parent != NULL) {
    // GitCred parent
    to = GitCred::New((void *)parent, false);
  } else {
    to = NanNull();
  }

// end convert_to_v8 block
  NanReturnValue(to);
}
NAN_METHOD(GitCredUsername::Username)
{
  NanScope();
  Handle<v8::Value> to;

  char *
  username =
    ObjectWrap::Unwrap<GitCredUsername>(args.This())->GetValue()->username;
// start convert_to_v8 block
  if (username) {
    to = NanNew<String>(username);
  } else {
    to = NanNull();
  }

  // end convert_to_v8 block
  NanReturnValue(to);
}
Persistent<Function> GitCredUsername::constructor_template;
