// This is a generated file, modify: generate/templates/class_content.cc.
#include <nan.h>
#include <string.h>
#include <chrono>
#include <thread>

extern "C" {
#include <git2.h>
}

#include "../include/functions/copy.h"
#include "../include/macros.h"
#include "../include/merge_file_result.h"


#include <iostream>

using namespace std;
using namespace v8;
using namespace node;

GitMergeFileResult::GitMergeFileResult(git_merge_file_result *raw, bool selfFreeing)
{
  this->raw = raw;
  this->selfFreeing = selfFreeing;
}

GitMergeFileResult::~GitMergeFileResult()
{

  // this will cause an error if you have a non-self-freeing object that also needs
  // to save values. Since the object that will eventually free the object has no
  // way of knowing to free these values.

}

void GitMergeFileResult::InitializeComponent(Handle<v8::Object> target)
{
  NanScope();

  Local<FunctionTemplate> tpl = NanNew<FunctionTemplate>(JSNewFunction);

  tpl->InstanceTemplate()->SetInternalFieldCount(1);
  tpl->SetClassName(NanNew<String>("MergeFileResult"));

  NODE_SET_PROTOTYPE_METHOD(tpl, "automergeable", Automergeable);
  NODE_SET_PROTOTYPE_METHOD(tpl, "path", Path);
  NODE_SET_PROTOTYPE_METHOD(tpl, "mode", Mode);
  NODE_SET_PROTOTYPE_METHOD(tpl, "ptr", Ptr);
  NODE_SET_PROTOTYPE_METHOD(tpl, "len", Len);

  Local<Function> _constructor_template = tpl->GetFunction();
  NanAssignPersistent(constructor_template, _constructor_template);
  target->Set(NanNew<String>("MergeFileResult"), _constructor_template);
}

NAN_METHOD(GitMergeFileResult::JSNewFunction)
{
  NanScope();

  if (args.Length() == 0 || !args[0]->IsExternal()) {
    return NanThrowError("A new GitMergeFileResult cannot be instantiated.");
  }

  GitMergeFileResult* object = new GitMergeFileResult(static_cast<git_merge_file_result *>(Handle<External>::Cast(args[0])->Value()), args[1]->BooleanValue());
  object->Wrap(args.This());

  NanReturnValue(args.This());
}

Handle<v8::Value> GitMergeFileResult::New(void *raw, bool selfFreeing)
{
  NanEscapableScope();
  Handle<v8::Value> argv[2] = { NanNew<External>((void *)raw), NanNew<Boolean>(selfFreeing) };
  return NanEscapeScope(NanNew<Function>(GitMergeFileResult::constructor_template)->NewInstance(2, argv));
}

git_merge_file_result *GitMergeFileResult::GetValue()
{
  return this->raw;
}

git_merge_file_result **GitMergeFileResult::GetRefValue()
{
  return this->raw == NULL ? NULL : &this->raw;
}

void GitMergeFileResult::ClearValue()
{
  this->raw = NULL;
}

NAN_METHOD(GitMergeFileResult::Automergeable)
{
  NanScope();
  Handle<v8::Value> to;

  unsigned int
  automergeable =
    ObjectWrap::Unwrap<GitMergeFileResult>(args.This())->GetValue()->automergeable;
// start convert_to_v8 block
  to = NanNew<Number>(automergeable);
  // end convert_to_v8 block
  NanReturnValue(to);
}
NAN_METHOD(GitMergeFileResult::Path)
{
  NanScope();
  Handle<v8::Value> to;

  const char *
  path =
    ObjectWrap::Unwrap<GitMergeFileResult>(args.This())->GetValue()->path;
// start convert_to_v8 block
  if (path) {
    to = NanNew<String>(path);
  } else {
    to = NanNull();
  }

  // end convert_to_v8 block
  NanReturnValue(to);
}
NAN_METHOD(GitMergeFileResult::Mode)
{
  NanScope();
  Handle<v8::Value> to;

  unsigned int
  mode =
    ObjectWrap::Unwrap<GitMergeFileResult>(args.This())->GetValue()->mode;
// start convert_to_v8 block
  to = NanNew<Number>(mode);
  // end convert_to_v8 block
  NanReturnValue(to);
}
NAN_METHOD(GitMergeFileResult::Ptr)
{
  NanScope();
  Handle<v8::Value> to;

  const char *
  ptr =
    ObjectWrap::Unwrap<GitMergeFileResult>(args.This())->GetValue()->ptr;
// start convert_to_v8 block
  if (ptr) {
    to = NanNew<String>(ptr);
  } else {
    to = NanNull();
  }

  // end convert_to_v8 block
  NanReturnValue(to);
}
NAN_METHOD(GitMergeFileResult::Len)
{
  NanScope();
  Handle<v8::Value> to;

  size_t
  len =
    ObjectWrap::Unwrap<GitMergeFileResult>(args.This())->GetValue()->len;
// start convert_to_v8 block
  to = NanNew<Number>(len);
  // end convert_to_v8 block
  NanReturnValue(to);
}
Persistent<Function> GitMergeFileResult::constructor_template;
